﻿Imports Autodesk.AutoCAD.Runtime


Namespace ObjectOrientedSample

    Public Class MyCommands

        <CommandMethod("RunTest")> _
        Public Sub Test()

            Dim pt1 As Point = New Point
            ' USe Step Into on the next line to step into SetLocation 
            pt1.SetLocation(10, 10)
            Dim xVal1 As Integer = pt1.X
            pt1.X = 9
            Dim xVal2 As Integer = pt1.X

            Dim pt2 As NewPoint = New NewPoint
            ' SetLocation, X and Y are inherited from Point class 
            pt2.SetLocation(20, 20)
            Dim xVal3 As Integer = pt2.X
            pt2.X = 9
            ' Z is new to the NewPoint class
            pt2.Z = 12
            Dim pt3 As Point = pt2
            ' pt3 is variable of type Point, but holds an object of type NewPoint
        End Sub

    End Class

    Public Class Point

        Private mXCoord As Integer
        Private mYCoord As Integer

        Public Sub SetLocation(ByVal x As Integer, ByVal y As Integer)
            Me.mXCoord = x
            Me.mYCoord = y
        End Sub

        Public Property X() As Integer
            Get
                Return Me.mXCoord
            End Get
            Set(ByVal value As Integer)
                Me.mXCoord = value
            End Set
        End Property

        Public Property Y() As Integer
            Get
                Return Me.mYCoord
            End Get
            Set(ByVal value As Integer)
                Me.mYCoord = value
            End Set
        End Property

    End Class

    Public Class NewPoint
        Inherits Point

        Private mZCoord As Integer

        Public Property Z() As Integer
            Get
                Return Me.mZCoord
            End Get
            Set(ByVal value As Integer)
                ' Don't accept negative Z values
                If value >= 0 Then
                    Me.mZCoord = value
                End If
            End Set
        End Property

    End Class

End Namespace